<?php

/**
 * shd API Insights
 *
 * @package shd
 * @subpackage API
 * @author Maik Rhode <maik.rhode@shd-online.de>
 */
class isys_api_model_shd_insights implements isys_api_model_interface
{

    /**
     * read all Insights entry
     *
     * @param array $p_params
     * @return array
     */
    public function read($p_params)
    {
        try {
            $return = smview_cmdb_dao_insightprofil::instance(isys_application::instance()->database)->getAllInsightProfil();
            return $return == null ? [] : $return;
        } catch (Exception $ex) {
            var_dump($ex->getMessage());
        }
    }
}
