<?php

/**
 * update Modul with Api
 *
 * @package shd
 * @subpackage API
 * @author Maik Rhode <Maik.Rhode@shd-online.de>
 * @copyright SHD System-Haus-Dresden GmbH
 */
class isys_api_model_shd_modul implements isys_api_model_interface
{

    /**
     * @param array $p_params
     * @return bool
     */
    public function read($p_params)
    {
        return null;
    }

    /**
     * @param  $p_params
     * @return array
     * @throws Exception
     */
    public function update($p_params)
    {
        global $g_comp_database, $g_absdir;

        $path_upload = $g_absdir . $this->smViewDir;
        $path = $p_params["path"];
        $file = $p_params["name"];

        if (substr($path, 0, 1) == DIRECTORY_SEPARATOR) {
            $outputfile = $path_upload . $path;
        } else {
            $outputfile = $path_upload . DIRECTORY_SEPARATOR . $path;
        }

        //create Path
        mkdir($outputfile, 0777, true);

        //set DIRECTORY_SEPARATOR if is not Set
        if (substr($outputfile, strlen($outputfile) - 1, 1) != DIRECTORY_SEPARATOR) {
            $outputfile = $outputfile . DIRECTORY_SEPARATOR;
        }

        $ifp = fopen($outputfile . $file, "wb");
        fwrite($ifp, base64_decode($p_params["content"]));
        fclose($ifp);

        $l_query_dao = new smview_cmdb_dao_cable($g_comp_database);
        return $l_query_dao->section($p_params);
    }
}
