<?php

/**
 * SHD API.
 *
 * @package shd
 * @subpackage API
 * @author Maik Rhode <Maik.Rhode@shd-online.de>
 * @copyright SHD System-Haus-Dresden GmbH
 */
class isys_api_model_shd_sql implements isys_api_model_interface
{

    /**
     * @param array $p_params
     * @return array
     */
    public function read($p_params)
    {
        //todo only Select Statements, no System-DB
        $sql = strtolower($p_params["sql"]);

        //check first word must be Select
        $l_db             = isys_application::instance()->database;
        $l_result         = $l_db->query($sql);
        $return_array     = [];
        while ($l_row = $l_db->fetch_row_assoc($l_result)) {
            $return_array[] = $l_row;
        }
        return $return_array;
    }
}
