<?php

/**
 * SHD API.
 *
 * @package shd
 * @subpackage API
 * @author Maik Rhode <Maik.Rhode@shd-online.de>
 * @copyright SHD System-Haus-Dresden GmbH
 */
class isys_api_model_shd_status implements isys_api_model_interface
{

    /**
     * @param  array $p_params
     * @return array
     * @throws Exception
     */
    public function read($p_params)
    {
        $objectIds = $p_params["object_ids"];
        if (isset($p_params["with_profile"]) == true) {
            $p_with_profile = $p_params["with_profile"];
        } else {
            $p_with_profile = false;
        }

        $return = [];
        foreach ($objectIds as $f_id) {
            $status = smview_cmdb_dao_status::instance(isys_application::instance()->database)->getStatus($f_id, $p_with_profile);
            if ($status !== []) {
                $return[$f_id] = smview_cmdb_dao_status::instance(isys_application::instance()->database)->getStatus($f_id, $p_with_profile);
            }
        }
        return $return;
    }
}
