/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ 8738:
/***/ (() => {

// extracted by mini-css-extract-plugin

/***/ }),

/***/ 8106:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.UpdaterCompose = void 0;
var React = __webpack_require__(7294);
var ajax_1 = __webpack_require__(166);
var UpdaterCompose = /** @class */ (function (_super) {
    __extends(UpdaterCompose, _super);
    function UpdaterCompose(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            modules: _this.props.modules
        };
        _this.getAvailableModuleVersion = _this.getAvailableModuleVersion.bind(_this);
        _this.updateModule = _this.updateModule.bind(_this);
        _this._setModuleProperty = _this._setModuleProperty.bind(_this);
        return _this;
    }
    UpdaterCompose.prototype.componentDidMount = function () {
        var _this = this;
        // get all available versions after one second
        setTimeout(function () {
            _this.state.modules.forEach(function (module) {
                _this.getAvailableModuleVersion(module.name);
            });
        }, 1000);
    };
    UpdaterCompose.prototype.getAvailableModuleVersion = function (moduleName) {
        var _this = this;
        this._setModuleProperty(moduleName, 'is_loading', true);
        var url = "".concat(this.props.ajax_url, "&func=get-available-version&module=").concat(moduleName);
        (0, ajax_1.loadAjax)(url, this.props.session)
            .then(function (res) {
            var response = __assign({}, res.data);
            _this._setModuleProperty(moduleName, 'available_version', response.available_version);
            _this._setModuleProperty(moduleName, 'is_updatable', response.is_updatable);
            _this._setModuleProperty(moduleName, 'is_loading', false);
        })
            .catch(function () {
            _this._setModuleProperty(moduleName, 'is_loading', false);
        });
    };
    UpdaterCompose.prototype.updateModule = function (moduleName) {
        var _this = this;
        this._setModuleProperty(moduleName, 'is_loading', true);
        var url = "".concat(this.props.ajax_url, "&func=update&module=").concat(moduleName);
        (0, ajax_1.loadAjax)(url, this.props.session)
            .then(function (res) {
            var response = __assign({}, res.data);
            _this._setModuleProperty(moduleName, 'installed_version', response.installed_version);
            _this._setModuleProperty(moduleName, 'is_updatable', false);
            _this._setModuleProperty(moduleName, 'is_loading', false);
        })
            .catch(function () {
            _this._setModuleProperty(moduleName, 'is_loading', false);
        });
    };
    UpdaterCompose.prototype._setModuleProperty = function (moduleName, property, value) {
        var searchModules = this.state.modules.filter(function (m) { return m.name == moduleName; });
        if (searchModules.length == 0) {
            return;
        }
        // update property
        var module = searchModules[0];
        module[property] = value;
        var allModules = this.state.modules.filter(function (m) { return m.name != moduleName; });
        allModules.push(module);
        // sort modules by name
        allModules.sort(function (a, b) {
            if (a.name == b.name) {
                return 0;
            }
            return a.name < b.name ? -1 : 1;
        });
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { modules: allModules })); });
    };
    UpdaterCompose.prototype.render = function () {
        var _this = this;
        var rows = [];
        if (this.state.modules.length > 0) {
            this.state.modules.forEach(function (module) {
                var button = null;
                if (module.is_updatable) {
                    button = React.createElement("button", { type: "button", className: "btn", disabled: module.is_loading, onClick: function () { _this.updateModule(module.name); } }, _this.props.language.LC__CMDB__CATG__SMVIEW__UPDATE);
                }
                var spinner = null;
                if (module.is_loading) {
                    spinner = React.createElement("img", { src: _this.props.spinner_url, alt: "..." });
                }
                rows.push(React.createElement("tr", { key: module.name },
                    React.createElement("td", null, module.title),
                    React.createElement("td", null, module.installed_version),
                    React.createElement("td", null,
                        module.available_version,
                        " ",
                        spinner),
                    React.createElement("td", null, button)));
            });
        }
        return React.createElement("div", { id: "update_container", className: "update-container" },
            React.createElement("table", { className: "mainTable" },
                React.createElement("thead", null,
                    React.createElement("tr", null,
                        React.createElement("th", null, this.props.language.LC__CMDB__CATG__SMVIEW__ADD_ON_NAME),
                        React.createElement("th", null, this.props.language.LC__CMDB__CATG__SMVIEW__CURRENT_VERSION),
                        React.createElement("th", null, this.props.language.LC__CMDB__CATG__SMVIEW__AVAILABLE_VERSION),
                        React.createElement("th", null, "\u00A0"))),
                React.createElement("tbody", null, rows)));
    };
    return UpdaterCompose;
}(React.Component));
exports.UpdaterCompose = UpdaterCompose;


/***/ }),

/***/ 166:
/***/ (function(__unused_webpack_module, exports) {

"use strict";

var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.loadAjax = void 0;
function loadAjax(ajax_url, session) {
    return __awaiter(this, void 0, void 0, function () {
        var res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetch(ajax_url, {
                        method: 'POST',
                        headers: {
                            Accept: 'application/json',
                            'Content-Type': 'application/json',
                            'X-RPC-Auth-Session': session
                        },
                        credentials: 'same-origin'
                    })];
                case 1:
                    res = _a.sent();
                    return [4 /*yield*/, res.json()];
                case 2: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.loadAjax = loadAjax;


/***/ }),

/***/ 4127:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
__webpack_require__(3153);
var React = __webpack_require__(7294);
var ReactDOM = __webpack_require__(3935);
var UpdaterCompose_1 = __webpack_require__(8106);
var config = document.getElementById('C__CATG__SMVIEW_REACT_CONFIG');
var cfg = JSON.parse(config.value);
ReactDOM.render(React.createElement(UpdaterCompose_1.UpdaterCompose, __assign({}, cfg)), document.getElementById('updater'));


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = __webpack_modules__;
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/chunk loaded */
/******/ 	(() => {
/******/ 		var deferred = [];
/******/ 		__webpack_require__.O = (result, chunkIds, fn, priority) => {
/******/ 			if(chunkIds) {
/******/ 				priority = priority || 0;
/******/ 				for(var i = deferred.length; i > 0 && deferred[i - 1][2] > priority; i--) deferred[i] = deferred[i - 1];
/******/ 				deferred[i] = [chunkIds, fn, priority];
/******/ 				return;
/******/ 			}
/******/ 			var notFulfilled = Infinity;
/******/ 			for (var i = 0; i < deferred.length; i++) {
/******/ 				var [chunkIds, fn, priority] = deferred[i];
/******/ 				var fulfilled = true;
/******/ 				for (var j = 0; j < chunkIds.length; j++) {
/******/ 					if ((priority & 1 === 0 || notFulfilled >= priority) && Object.keys(__webpack_require__.O).every((key) => (__webpack_require__.O[key](chunkIds[j])))) {
/******/ 						chunkIds.splice(j--, 1);
/******/ 					} else {
/******/ 						fulfilled = false;
/******/ 						if(priority < notFulfilled) notFulfilled = priority;
/******/ 					}
/******/ 				}
/******/ 				if(fulfilled) {
/******/ 					deferred.splice(i--, 1)
/******/ 					var r = fn();
/******/ 					if (r !== undefined) result = r;
/******/ 				}
/******/ 			}
/******/ 			return result;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/global */
/******/ 	(() => {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/jsonp chunk loading */
/******/ 	(() => {
/******/ 		// no baseURI
/******/ 		
/******/ 		// object to store loaded and loading chunks
/******/ 		// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 		// [resolve, reject, Promise] = chunk loading, 0 = chunk loaded
/******/ 		var installedChunks = {
/******/ 			"updater": 0
/******/ 		};
/******/ 		
/******/ 		// no chunk on demand loading
/******/ 		
/******/ 		// no prefetching
/******/ 		
/******/ 		// no preloaded
/******/ 		
/******/ 		// no HMR
/******/ 		
/******/ 		// no HMR manifest
/******/ 		
/******/ 		__webpack_require__.O.j = (chunkId) => (installedChunks[chunkId] === 0);
/******/ 		
/******/ 		// install a JSONP callback for chunk loading
/******/ 		var webpackJsonpCallback = (parentChunkLoadingFunction, data) => {
/******/ 			var [chunkIds, moreModules, runtime] = data;
/******/ 			// add "moreModules" to the modules object,
/******/ 			// then flag all "chunkIds" as loaded and fire callback
/******/ 			var moduleId, chunkId, i = 0;
/******/ 			if(chunkIds.some((id) => (installedChunks[id] !== 0))) {
/******/ 				for(moduleId in moreModules) {
/******/ 					if(__webpack_require__.o(moreModules, moduleId)) {
/******/ 						__webpack_require__.m[moduleId] = moreModules[moduleId];
/******/ 					}
/******/ 				}
/******/ 				if(runtime) var result = runtime(__webpack_require__);
/******/ 			}
/******/ 			if(parentChunkLoadingFunction) parentChunkLoadingFunction(data);
/******/ 			for(;i < chunkIds.length; i++) {
/******/ 				chunkId = chunkIds[i];
/******/ 				if(__webpack_require__.o(installedChunks, chunkId) && installedChunks[chunkId]) {
/******/ 					installedChunks[chunkId][0]();
/******/ 				}
/******/ 				installedChunks[chunkId] = 0;
/******/ 			}
/******/ 			return __webpack_require__.O(result);
/******/ 		}
/******/ 		
/******/ 		var chunkLoadingGlobal = self["webpackChunksmview"] = self["webpackChunksmview"] || [];
/******/ 		chunkLoadingGlobal.forEach(webpackJsonpCallback.bind(null, 0));
/******/ 		chunkLoadingGlobal.push = webpackJsonpCallback.bind(null, chunkLoadingGlobal.push.bind(chunkLoadingGlobal));
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module depends on other loaded chunks and execution need to be delayed
/******/ 	__webpack_require__.O(undefined, ["vendors"], () => (__webpack_require__(4127)))
/******/ 	var __webpack_exports__ = __webpack_require__.O(undefined, ["vendors"], () => (__webpack_require__(8738)))
/******/ 	__webpack_exports__ = __webpack_require__.O(__webpack_exports__);
/******/ 	
/******/ })()
;