<?php
/**
 * i-doit - Documentation and CMDB solution for IT environments
 *
 * This file is part of the i-doit framework. Modify at your own risk.
 *
 * Please visit http://www.i-doit.com/license for a full copyright and license information.
 *
 * @version     1.8.3
 * @package     i-doit
 * @author      synetics GmbH
 * @copyright   synetics GmbH
 * @url         http://www.i-doit.com
 * @license     http://www.i-doit.com/license
 */

/**
 * i-doit
 *
 * Template Module Dao.
 *
 * @package     i-doit
 * @subpackage  Modules
 * @author      Dennis Stücken <dstuecken@i-doit.org>
 * @version     0.9
 * @copyright   synetics GmbH
 * @license     http://www.i-doit.com/license
 */

class smview_cmdb_dao_file extends isys_module_dao
{
    protected static $m_instance = null;

    /**
     * Retrieve the Map.
     *
     * @param   integer $obj_id
     *
     * @return  array
     * @throws  Exception
     */
    public function get_dimage($obj_id)
    {
        try {
            $l_sql = "SELECT * FROM isys_catg_file_list
			LEFT JOIN isys_connection ON isys_connection__id = isys_catg_file_list__isys_connection__id
			LEFT JOIN isys_cats_file_list ON isys_cats_file_list__isys_obj__id = isys_connection__isys_obj__id
			LEFT JOIN isys_file_version ON isys_file_version__id = isys_cats_file_list__isys_file_version__id
            LEFT JOIN isys_file_physical ON isys_file_physical__id = isys_file_version__isys_file_physical__id
                    WHERE TRUE AND isys_catg_file_list.isys_catg_file_list__isys_obj__id = " . $obj_id; // . " AND isys_file_physical__filename LIKE '%_dimage%'";
            $l_row = $this->retrieve($l_sql)->get_row();
            if (empty($l_row)) {
                return [];
            }
            return $l_row;
        } catch (Exception $ex) {
        }
    }


    /**
     * Get data method. Unused.
     *
     * @return  null
     */
    public function get_data()
    {
        return null;
    }
}
