<style>
    p {
        padding-top: 20px;
        margin-left: 15px;
        color: #515151;
        font-size: 14px;
    }

    #api_enabled:empty {
        margin-left: -999px;
    }

    #api_enabled:empty ~ label {
        position: relative;
        float: left;
        line-height: 1.6em;
        text-indent: 4em;
        margin: 0.2em 0;
        cursor: pointer;
        -webkit-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;

    }

    #api_enabled:empty ~ label:before,
    #api_enabled:empty ~ label:after {
        position: absolute;
        display: block;
        top: 0;
        bottom: 0;
        left: 0;
        content: ' ';
        width: 3.6em;
        height: 24px;
        background-color: #c33;
        border-radius: 0.3em;
        box-shadow: inset 0 0.2em 0 rgba(0, 0, 0, 0.3);
        -webkit-transition: all 100ms ease-in;
        transition: all 100ms ease-in;
    }

    #api_enabled:empty ~ label:after {
        width: 1.4em;
        top: 0.1em;
        bottom: 0.1em;
        margin-left: 0.1em;
        background-color: #fff;
        border-radius: 0.15em;
        box-shadow: inset 0 -0.2em 0 rgba(0, 0, 0, 0.2);
    }

    #api_enabled:checked ~ label:before {
        background-color: #393;
    }

    #api_enabled:checked ~ label:after {
        margin-left: 2em;
    }

    .switch {
        margin: 20px 0 30px 15px;
    }
</style>

<body>
    <p>[{isys type="lang" ident="LC__MODULE__SMVIEW__API_TITLE"}]:</p>
    <div class="switch">
        <input type="checkbox" id="api_enabled" name="api_enabled" [{if $api_enabled}]checked="checked"[{/if}] onchange="submit();" />
        <label for="api_enabled"></label>
    </div>

    <div class="switch">
        <a href="images/shd-smview.fdg" class="btn" target="_blank">[{isys type="lang" ident="LC__MODULE__SMVIEW__DOWNLOAD_CONFIG"}]</a>
    </div>

</body>
