<?php

/**
 * shd API filters
 *
 * @package SHD
 * @subpackage API
 * @author Maik Rhode <Maik.Rhode@shd-online.de>
 * @copyright SHD System-Haus-Dresden GmbH
 */
class isys_api_model_shd_filters implements isys_api_model_interface
{
    /**
     * @param  array $p_params
     * @return array
     * @throws Exception
     */
    public function read($p_params)
    {
        global $g_comp_session;

        $userId = $g_comp_session->get_user_id();
        $p_params["user_id"] = $userId;
        return smview_cmdb_dao_filter::instance(isys_application::instance()->database)->get_all_filters($p_params);
    }
}
