<?php

/**
 * SHD API.
 *
 * @package shd
 * @subpackage API
 * @author Maik Rhode <Maik.Rhode@shd-online.de>
 * @copyright SHD System-Haus-Dresden GmbH
 */
class isys_api_model_shd_queryfast implements isys_api_model_interface
{

    /**
     * @param array $p_params
     * @return array
     */
    public function read($p_params)
    {
        global $g_comp_database;
        $l_query_dao = new smview_cmdb_dao_queryfast($g_comp_database);
        return $l_query_dao->read($p_params);
    }

    /**
     * @param $p_params
     * @return array
     */
    public function readfast($p_params)
    {
        global $g_comp_database;
        $l_query_dao = new smview_cmdb_dao_queryfast($g_comp_database);
        return $l_query_dao->read($p_params);
    }
}
