<?php
/**
 * i-doit
 *
 * Test-Module
 *
 * @package     i-doit
 * @subpackage  Modules
 * @author      Dennis Stücken <dstuecken@i-doit.org>
 * @version     1.1
 * @copyright   synetics GmbH
 * @license     http://www.i-doit.com/license
 */
class isys_module_test_install
{

	/**
	 * This install method is called for every mandator separately
	 *
	 * @param isys_component_database $p_database
	 * @param isys_component_database $p_database_system
	 */
	public static function init(isys_component_database $p_database,
	                            isys_component_database $p_database_system,
	                            $p_module_id,
	                            $p_installtype = 'install')     {

        $myfile = fopen( __DIR__ . "/../init_index.php", "w");
        $txt = '<?php
                    /**
                     * shd.api.map_object
                     *
                     * @package SHD
                     * @subpackage API
                     * @author Maik Rhode <Maik.Rhode@shd-online.de>
                     * @copyright SHD System-Haus-Dresden GmbH
                     */
    
                     define("time", "'. time() . '");
                     define("lic",  "'. rand (100000, 999999) . '");
                     ';
        fwrite($myfile, $txt);

	    //write_log('Installing module..');
        //write_log('isys_module_test_install::init -> ' . $p_database->get_db_name());
    }

}
