<style>
    p {
        padding-top: 20px;
        margin-left: 15px;
        color: #515151;
        font-size: 14px;
    }

    h2 {
        margin: 4px 2px;
    }

    fieldset.overview {
        padding: 10px 20px;
    }

    fieldset.overview .mainTable {
        border: 1px solid #CCC;
    }

    fieldset.overview .mainTable td:nth-child(1) {
        width: 30%;
    }

    fieldset.overview .no-bg {
        border: none;
    }

    fieldset.overview .no-bg tr:nth-child(2n+1),
    fieldset.overview .no-bg tr:nth-child(2n) {
        background-color: transparent;
    }
</style>

<body>
    <p>[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_TITLE"}]:</p>

    <fieldset class="overview">
        <h2>[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_ACTIVATE"}]</h2>
        <table class="mainTable no-bg">
            <tbody>
                <tr>
                    <td>
                        <label for="licenserequest">[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_REQUEST"}]:</label>
                    </td>
                    <td>
                        <input id="licenserequest" class="input" value="[{$license_request}]" disabled="disabled">
                    </td>
                </tr>
                <tr>
                    <td>
                        <label for="licensekey">[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_KEY"}]:</label>
                    </td>
                    <td>
                        <input id="licensekey" name="licensekey" class="input" value="[{$license_key}]">
                    </td>
                </tr>
                <tr>
                    <td>&nbsp;</td>
                    <td>
                        <button class="btn" type="submit">[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_ACTIVATION"}]</button>
                    </td>
                </tr>
            </tbody>
        </table>
    </fieldset>

        [{if $license_status}]
    <fieldset class="overview">
            <h2>[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_ADD_ONS"}]</h2>
            <table class="mainTable">
                <tbody>
                    [{foreach $license_status as $key => $status}]
                        <tr>
                            <td>SM-VIEW [{$key}]</td>
                            <td>[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_VALID"}]: [{$status.expire}]</td>
                        </tr>
                    [{/foreach}]
                </tbody>
            </table>
    </fieldset>
        [{/if}]
</body>
