<style>
    h2 {
        margin: 4px 2px;
    }

    fieldset.overview {
        padding: 10px 20px;
    }

    fieldset.overview .mainTable {
        border: 1px solid #CCC;
    }

    fieldset.overview .mainTable td:nth-child(1) {
        width: 30%;
    }

    fieldset.overview .no-bg {
        border: none;
    }

    fieldset.overview .no-bg tr:nth-child(2n+1),
    fieldset.overview .no-bg tr:nth-child(2n) {
        background-color: transparent;
    }
</style>

<body>

<fieldset class="overview">
    <h2>[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_GENERATE"}]</h2>
    <table class="mainTable no-bg">
        <tbody>
        <tr>
            <td>
                <label for="license_request">[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_REQUEST"}]:</label>
            </td>
            <td>
                <input id="license_request" name="license_request" class="input" value="[{$license_request}]">
            </td>
        </tr>
        <tr>
            <td>
                <label for="object_count">[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_OBJECT_COUNT"}]:</label>
            </td>
            <td>
                <input id="object_count" name="object_count" class="input" value="[{$object_count}]" disabled="disabled"/>
            </td>
        </tr>
        <tr>
            <td>
                <label for="object_count">[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_VALID_UNTIL"}]:</label>
            </td>
            <td>
                <input id="month" name="month" class="input input-small" value="[{$month}]" placeholder="12"/>
                <input id="year" name="year" class="input input-small" value="[{$year}]" placeholder="2025"/>
            </td>
        </tr>
        <tr>
            <td>
                <label for="modules[]">[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_MODULES"}]:</label>
            </td>
            <td>
                <table>
                    [{foreach $modules as $module}]
                        <tr>
                            <td><input type="checkbox" name="modules[]" class="input" value="[{$module}]" [{if in_array($module, $selected_modules)}] checked="checked" [{/if}] /></td>
                            <td>[{$module}]</td>
                        </tr>
                    [{/foreach}]
                </table>
            </td>
        </tr>
        <tr>
            <td>
                <label for="license_key">[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_KEY"}]:</label>
            </td>
            <td>
                <input id="license_key" name="license_key" class="input" value="[{$license_key}]">
            </td>
        </tr>
        <tr>
            <td>&nbsp;</td>
            <td>
                <button class="btn" type="submit">[{isys type="lang" ident="LC__MODULE__SMVIEW__LICENSE_GENERATION"}]</button>
            </td>
        </tr>
        </tbody>
    </table>
</fieldset>
</body>
